TypeKindVisitorPreview (Java SE 25 & JDK 25)
Description: declaration: module: java.compiler, package: javax.lang.model.util, class: TypeKindVisitorPreview
Keywords: javax.lang.model.util.TypeKindVisitorPreview class

# Class TypeKindVisitorPreview<R,P>

java.lang.Object
javax.lang.model.util.AbstractTypeVisitor6<R,P>
javax.lang.model.util.SimpleTypeVisitor6<R,P>
javax.lang.model.util.TypeKindVisitor6<R,P>
javax.lang.model.util.TypeKindVisitor7<R,P>
javax.lang.model.util.TypeKindVisitor8<R,P>
javax.lang.model.util.TypeKindVisitor9<R,P>
javax.lang.model.util.TypeKindVisitor14<R,P>
javax.lang.model.util.TypeKindVisitorPreview<R,P>

Type Parameters:
  `R` - the return type of this visitor's methods. Use `Void` for visitors that do not need to return results.
  `P` - the type of the additional parameter to this visitor's methods. Use `Void` for visitors that do not need an additional parameter.

All Implemented Interfaces:
  `TypeVisitor<R,P>`

@SupportedSourceVersion(RELEASE_25) public class TypeKindVisitorPreview<R,P> extends TypeKindVisitor14<R,P>
`TypeKindVisitorPreview` is a reflective preview API of the Java platform.
Preview features may be removed in a future release, or upgraded to permanent features of the Java platform.
A visitor of types based on their kind with default behavior appropriate for a preview source version. For types `Xyz` that may have more than one kind, the `visitXyz` methods in this class delegate to the `visitXyzAsKind` method corresponding to the first argument's kind. The `visitXyzAsKind` methods call `defaultAction`, passing their arguments to `defaultAction`'s corresponding parameters.

API Note:
  Methods in this class may be overridden subject to their general contract.
Since:
  23
See Also:
  - Expected visitor evolution
  - Compatibility note for subclasses
  - `TypeKindVisitor6`
  - `TypeKindVisitor7`
  - `TypeKindVisitor8`
  - `TypeKindVisitor9`
  - `TypeKindVisitor14`

- ## Field Summary

  ### Fields declared in class SimpleTypeVisitor6

  `DEFAULT_VALUE`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `TypeKindVisitorPreview()`
  Constructor for concrete subclasses to call; uses `null` for the default value.
  `protected`
  `TypeKindVisitorPreview(R defaultValue)`
  Constructor for concrete subclasses to call; uses the argument for the default value.

- ## Method Summary

  ### Methods declared in class TypeKindVisitor9

  `visitNoTypeAsModule`

  ### Methods declared in class TypeKindVisitor8

  `visitIntersection`

  ### Methods declared in class TypeKindVisitor7

  `visitUnion`

  ### Methods declared in class TypeKindVisitor6

  `visitNoType, visitNoTypeAsNone, visitNoTypeAsPackage, visitNoTypeAsVoid, visitPrimitive, visitPrimitiveAsBoolean, visitPrimitiveAsByte, visitPrimitiveAsChar, visitPrimitiveAsDouble, visitPrimitiveAsFloat, visitPrimitiveAsInt, visitPrimitiveAsLong, visitPrimitiveAsShort`

  ### Methods declared in class SimpleTypeVisitor6

  `defaultAction, visitArray, visitDeclared, visitError, visitExecutable, visitNull, visitTypeVariable, visitWildcard`

  ### Methods declared in class AbstractTypeVisitor6

  `visit, visit, visitUnknown`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### TypeKindVisitorPreview

    protected TypeKindVisitorPreview()
    Constructor for concrete subclasses to call; uses `null` for the default value.

  - ### TypeKindVisitorPreview

    protected TypeKindVisitorPreview(R defaultValue)
    Constructor for concrete subclasses to call; uses the argument for the default value.
    Parameters:
      `defaultValue` - the value to assign to `SimpleTypeVisitor6.DEFAULT_VALUE`